1. Packages
  2. Packages
  3. Powerscale Provider
  4. API Docs
  5. getNetworkRule
Viewing docs for powerscale 1.8.1
published on Wednesday, Apr 1, 2026 by dell
Viewing docs for powerscale 1.8.1
published on Wednesday, Apr 1, 2026 by dell

    This datasource is used to query the existing network rules from PowerScale array. The information fetched from this datasource can be used for getting the details or for further processing in resource block.

    Example Usage

    import * as pulumi from "@pulumi/pulumi";
    import * as powerscale from "@pulumi/powerscale";
    
    //Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
    //
    //Licensed under the Mozilla Public License Version 2.0 (the "License");
    //you may not use this file except in compliance with the License.
    //You may obtain a copy of the License at
    //
    //    http://mozilla.org/MPL/2.0/
    //
    //
    //Unless required by applicable law or agreed to in writing, software
    //distributed under the License is distributed on an "AS IS" BASIS,
    //WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    //See the License for the specific language governing permissions and
    //limitations under the License.
    // This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
    // Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
    const test = powerscale.getNetworkRule({
        filter: {
            names: ["rule0"],
            groupnet: "groupnet0",
            subnet: "subnet0",
            pool: "pool0",
        },
    });
    export const powerscaleNetworkRule = test;
    // Returns all PowerScale network rules on PowerScale array
    const all = powerscale.getNetworkRule({});
    export const powerscaleNetworkRuleDataAll = all;
    
    import pulumi
    import pulumi_powerscale as powerscale
    
    #Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
    #
    #Licensed under the Mozilla Public License Version 2.0 (the "License");
    #you may not use this file except in compliance with the License.
    #You may obtain a copy of the License at
    #
    #    http://mozilla.org/MPL/2.0/
    #
    #
    #Unless required by applicable law or agreed to in writing, software
    #distributed under the License is distributed on an "AS IS" BASIS,
    #WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    #See the License for the specific language governing permissions and
    #limitations under the License.
    # This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
    # Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
    test = powerscale.get_network_rule(filter={
        "names": ["rule0"],
        "groupnet": "groupnet0",
        "subnet": "subnet0",
        "pool": "pool0",
    })
    pulumi.export("powerscaleNetworkRule", test)
    # Returns all PowerScale network rules on PowerScale array
    all = powerscale.get_network_rule()
    pulumi.export("powerscaleNetworkRuleDataAll", all)
    
    package main
    
    import (
    	"github.com/pulumi/pulumi-terraform-provider/sdks/go/powerscale/powerscale"
    	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
    )
    
    func main() {
    	pulumi.Run(func(ctx *pulumi.Context) error {
    		// Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
    		//
    		// Licensed under the Mozilla Public License Version 2.0 (the "License");
    		// you may not use this file except in compliance with the License.
    		// You may obtain a copy of the License at
    		//
    		//	http://mozilla.org/MPL/2.0/
    		//
    		// Unless required by applicable law or agreed to in writing, software
    		// distributed under the License is distributed on an "AS IS" BASIS,
    		// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    		// See the License for the specific language governing permissions and
    		// limitations under the License.
    		// This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
    		// Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
    		test, err := powerscale.LookupNetworkRule(ctx, &powerscale.LookupNetworkRuleArgs{
    			Filter: powerscale.GetNetworkRuleFilter{
    				Names: []string{
    					"rule0",
    				},
    				Groupnet: pulumi.StringRef("groupnet0"),
    				Subnet:   pulumi.StringRef("subnet0"),
    				Pool:     pulumi.StringRef("pool0"),
    			},
    		}, nil)
    		if err != nil {
    			return err
    		}
    		ctx.Export("powerscaleNetworkRule", test)
    		// Returns all PowerScale network rules on PowerScale array
    		all, err := powerscale.LookupNetworkRule(ctx, &powerscale.LookupNetworkRuleArgs{}, nil)
    		if err != nil {
    			return err
    		}
    		ctx.Export("powerscaleNetworkRuleDataAll", all)
    		return nil
    	})
    }
    
    using System.Collections.Generic;
    using System.Linq;
    using Pulumi;
    using Powerscale = Pulumi.Powerscale;
    
    return await Deployment.RunAsync(() => 
    {
        //Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
        //
        //Licensed under the Mozilla Public License Version 2.0 (the "License");
        //you may not use this file except in compliance with the License.
        //You may obtain a copy of the License at
        //
        //    http://mozilla.org/MPL/2.0/
        //
        //
        //Unless required by applicable law or agreed to in writing, software
        //distributed under the License is distributed on an "AS IS" BASIS,
        //WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
        //See the License for the specific language governing permissions and
        //limitations under the License.
        // This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
        // Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
        var test = Powerscale.GetNetworkRule.Invoke(new()
        {
            Filter = new Powerscale.Inputs.GetNetworkRuleFilterInputArgs
            {
                Names = new[]
                {
                    "rule0",
                },
                Groupnet = "groupnet0",
                Subnet = "subnet0",
                Pool = "pool0",
            },
        });
    
        // Returns all PowerScale network rules on PowerScale array
        var all = Powerscale.GetNetworkRule.Invoke();
    
        return new Dictionary<string, object?>
        {
            ["powerscaleNetworkRule"] = test,
            ["powerscaleNetworkRuleDataAll"] = all,
        };
    });
    
    package generated_program;
    
    import com.pulumi.Context;
    import com.pulumi.Pulumi;
    import com.pulumi.core.Output;
    import com.pulumi.powerscale.PowerscaleFunctions;
    import com.pulumi.powerscale.inputs.GetNetworkRuleArgs;
    import com.pulumi.powerscale.inputs.GetNetworkRuleFilterArgs;
    import java.util.List;
    import java.util.ArrayList;
    import java.util.Map;
    import java.io.File;
    import java.nio.file.Files;
    import java.nio.file.Paths;
    
    public class App {
        public static void main(String[] args) {
            Pulumi.run(App::stack);
        }
    
        public static void stack(Context ctx) {
            //Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
            //
            //Licensed under the Mozilla Public License Version 2.0 (the "License");
            //you may not use this file except in compliance with the License.
            //You may obtain a copy of the License at
            //
            //    http://mozilla.org/MPL/2.0/
            //
            //
            //Unless required by applicable law or agreed to in writing, software
            //distributed under the License is distributed on an "AS IS" BASIS,
            //WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
            //See the License for the specific language governing permissions and
            //limitations under the License.
            // This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
            // Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
            final var test = PowerscaleFunctions.getNetworkRule(GetNetworkRuleArgs.builder()
                .filter(GetNetworkRuleFilterArgs.builder()
                    .names("rule0")
                    .groupnet("groupnet0")
                    .subnet("subnet0")
                    .pool("pool0")
                    .build())
                .build());
    
            ctx.export("powerscaleNetworkRule", test);
            // Returns all PowerScale network rules on PowerScale array
            final var all = PowerscaleFunctions.getNetworkRule(GetNetworkRuleArgs.builder()
                .build());
    
            ctx.export("powerscaleNetworkRuleDataAll", all);
        }
    }
    
    variables:
      # /*
      # Copyright (c) 2023-2024 Dell Inc., or its subsidiaries. All Rights Reserved.
    
      # Licensed under the Mozilla Public License Version 2.0 (the "License");
      # you may not use this file except in compliance with the License.
      # You may obtain a copy of the License at
    
      #     http://mozilla.org/MPL/2.0/
    
    
      # Unless required by applicable law or agreed to in writing, software
      # distributed under the License is distributed on an "AS IS" BASIS,
      # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      # See the License for the specific language governing permissions and
      # limitations under the License.
      # */
    
    
      # This Terraform DataSource is used to query the details of existing network rules from PowerScale array.
    
      # Returns a list of PowerScale network rules based on names and query parameters specified in the filter block.
      test:
        fn::invoke:
          function: powerscale:getNetworkRule
          arguments:
            filter:
              names:
                - rule0
              groupnet: groupnet0
              subnet: subnet0
              pool: pool0
      # Returns all PowerScale network rules on PowerScale array
      all:
        fn::invoke:
          function: powerscale:getNetworkRule
          arguments: {}
    outputs:
      # Output value of above block by executing 'terraform output' command
      # You can use the the fetched information by the variable data.powerscale_network_rule.test
      powerscaleNetworkRule: ${test}
      # Output value of above block by executing 'terraform output' command
      # You can use the the fetched information by the variable data.powerscale_network_rule.all
      powerscaleNetworkRuleDataAll: ${all}
    

    Using getNetworkRule

    Two invocation forms are available. The direct form accepts plain arguments and either blocks until the result value is available, or returns a Promise-wrapped result. The output form accepts Input-wrapped arguments and returns an Output-wrapped result.

    function getNetworkRule(args: GetNetworkRuleArgs, opts?: InvokeOptions): Promise<GetNetworkRuleResult>
    function getNetworkRuleOutput(args: GetNetworkRuleOutputArgs, opts?: InvokeOptions): Output<GetNetworkRuleResult>
    def get_network_rule(filter: Optional[GetNetworkRuleFilter] = None,
                         opts: Optional[InvokeOptions] = None) -> GetNetworkRuleResult
    def get_network_rule_output(filter: pulumi.Input[Optional[GetNetworkRuleFilterArgs]] = None,
                         opts: Optional[InvokeOptions] = None) -> Output[GetNetworkRuleResult]
    func LookupNetworkRule(ctx *Context, args *LookupNetworkRuleArgs, opts ...InvokeOption) (*LookupNetworkRuleResult, error)
    func LookupNetworkRuleOutput(ctx *Context, args *LookupNetworkRuleOutputArgs, opts ...InvokeOption) LookupNetworkRuleResultOutput

    > Note: This function is named LookupNetworkRule in the Go SDK.

    public static class GetNetworkRule 
    {
        public static Task<GetNetworkRuleResult> InvokeAsync(GetNetworkRuleArgs args, InvokeOptions? opts = null)
        public static Output<GetNetworkRuleResult> Invoke(GetNetworkRuleInvokeArgs args, InvokeOptions? opts = null)
    }
    public static CompletableFuture<GetNetworkRuleResult> getNetworkRule(GetNetworkRuleArgs args, InvokeOptions options)
    public static Output<GetNetworkRuleResult> getNetworkRule(GetNetworkRuleArgs args, InvokeOptions options)
    
    fn::invoke:
      function: powerscale:index/getNetworkRule:getNetworkRule
      arguments:
        # arguments dictionary

    The following arguments are supported:

    getNetworkRule Result

    The following output properties are available:

    Id string
    Unique identifier of the network rule.
    NetworkRules List<GetNetworkRuleNetworkRule>
    List of Network Rules.
    Filter GetNetworkRuleFilter
    Id string
    Unique identifier of the network rule.
    NetworkRules []GetNetworkRuleNetworkRule
    List of Network Rules.
    Filter GetNetworkRuleFilter
    id String
    Unique identifier of the network rule.
    networkRules List<GetNetworkRuleNetworkRule>
    List of Network Rules.
    filter GetNetworkRuleFilter
    id string
    Unique identifier of the network rule.
    networkRules GetNetworkRuleNetworkRule[]
    List of Network Rules.
    filter GetNetworkRuleFilter
    id str
    Unique identifier of the network rule.
    network_rules Sequence[GetNetworkRuleNetworkRule]
    List of Network Rules.
    filter GetNetworkRuleFilter
    id String
    Unique identifier of the network rule.
    networkRules List<Property Map>
    List of Network Rules.
    filter Property Map

    Supporting Types

    GetNetworkRuleFilter

    Groupnet string
    If specified, only rules for this groupnet will be returned.
    Names List<string>
    Filter network rules by names.
    Pool string
    If specified, only rules for this pool will be returned.
    Subnet string
    If specified, only rules for this subnet will be returned.
    Groupnet string
    If specified, only rules for this groupnet will be returned.
    Names []string
    Filter network rules by names.
    Pool string
    If specified, only rules for this pool will be returned.
    Subnet string
    If specified, only rules for this subnet will be returned.
    groupnet String
    If specified, only rules for this groupnet will be returned.
    names List<String>
    Filter network rules by names.
    pool String
    If specified, only rules for this pool will be returned.
    subnet String
    If specified, only rules for this subnet will be returned.
    groupnet string
    If specified, only rules for this groupnet will be returned.
    names string[]
    Filter network rules by names.
    pool string
    If specified, only rules for this pool will be returned.
    subnet string
    If specified, only rules for this subnet will be returned.
    groupnet str
    If specified, only rules for this groupnet will be returned.
    names Sequence[str]
    Filter network rules by names.
    pool str
    If specified, only rules for this pool will be returned.
    subnet str
    If specified, only rules for this subnet will be returned.
    groupnet String
    If specified, only rules for this groupnet will be returned.
    names List<String>
    Filter network rules by names.
    pool String
    If specified, only rules for this pool will be returned.
    subnet String
    If specified, only rules for this subnet will be returned.

    GetNetworkRuleNetworkRule

    Description string
    Description for the provisioning rule.
    Groupnet string
    Name of the groupnet this rule belongs to
    Id string
    Unique rule ID.
    Iface string
    Interface name the provisioning rule applies to.
    Name string
    Name of the provisioning rule.
    NodeType string
    Node type the provisioning rule applies to.
    Pool string
    Name of the pool this rule belongs to.
    Subnet string
    Name of the subnet this rule belongs to.
    Description string
    Description for the provisioning rule.
    Groupnet string
    Name of the groupnet this rule belongs to
    Id string
    Unique rule ID.
    Iface string
    Interface name the provisioning rule applies to.
    Name string
    Name of the provisioning rule.
    NodeType string
    Node type the provisioning rule applies to.
    Pool string
    Name of the pool this rule belongs to.
    Subnet string
    Name of the subnet this rule belongs to.
    description String
    Description for the provisioning rule.
    groupnet String
    Name of the groupnet this rule belongs to
    id String
    Unique rule ID.
    iface String
    Interface name the provisioning rule applies to.
    name String
    Name of the provisioning rule.
    nodeType String
    Node type the provisioning rule applies to.
    pool String
    Name of the pool this rule belongs to.
    subnet String
    Name of the subnet this rule belongs to.
    description string
    Description for the provisioning rule.
    groupnet string
    Name of the groupnet this rule belongs to
    id string
    Unique rule ID.
    iface string
    Interface name the provisioning rule applies to.
    name string
    Name of the provisioning rule.
    nodeType string
    Node type the provisioning rule applies to.
    pool string
    Name of the pool this rule belongs to.
    subnet string
    Name of the subnet this rule belongs to.
    description str
    Description for the provisioning rule.
    groupnet str
    Name of the groupnet this rule belongs to
    id str
    Unique rule ID.
    iface str
    Interface name the provisioning rule applies to.
    name str
    Name of the provisioning rule.
    node_type str
    Node type the provisioning rule applies to.
    pool str
    Name of the pool this rule belongs to.
    subnet str
    Name of the subnet this rule belongs to.
    description String
    Description for the provisioning rule.
    groupnet String
    Name of the groupnet this rule belongs to
    id String
    Unique rule ID.
    iface String
    Interface name the provisioning rule applies to.
    name String
    Name of the provisioning rule.
    nodeType String
    Node type the provisioning rule applies to.
    pool String
    Name of the pool this rule belongs to.
    subnet String
    Name of the subnet this rule belongs to.

    Package Details

    Repository
    powerscale dell/terraform-provider-powerscale
    License
    Notes
    This Pulumi package is based on the powerscale Terraform Provider.
    Viewing docs for powerscale 1.8.1
    published on Wednesday, Apr 1, 2026 by dell
      Try Pulumi Cloud free. Your team will thank you.